﻿@model IEnumerable<ProyectoIdentity.Models.UserApp>

@{
    ViewData["Title"] = "Administración de usuarios";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1 class="text-center">Administración de Usuarios</h1>

@if (TempData["Correcto"] is not null)
{
    <div class="alert alert-success alert-dismissible fade show" role="alert">
        @TempData["Correcto"]
        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
    </div>
}

@if (TempData["Error"] is not null)
{
    <div class="alert alert-danger alert-dismissible fade show" role="alert">
        @TempData["Error"]
        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
    </div>
}

<div class="row">
    <div class="col-sm-3 offset-9">
        <a asp-action="Crear" asp-controller="Roles" class="btn btn-primary w-100">Crear nuevo rol</a>
    </div>
</div>

<div class="row">
    <div class="col-sm-12">

        <div class="card border">
            <div class="card-header">
                <h3><strong>Lista de usuarios</strong></h3>
            </div>
        </div>

        <div class="card-body">
            <div class="table-responsive">
                @if (Model.Count() > 0)
                {
                    <table class="d-lg-table table-bordered" id="tablaUsuarios" width="100%" cellspacing="0">
                        <thead>
                            <tr>
                                <th>@Html.DisplayNameFor(m => m.Nombre)</th>
                                <th>@Html.DisplayNameFor(m => m.Email)</th>
                                <th>@Html.DisplayNameFor(m => m.Telefono)</th>
                                <th>@Html.DisplayNameFor(m => m.Rol)</th>
                                <th>Acciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>@Html.DisplayFor(m => item.Nombre)</td>
                                    <td>@Html.DisplayFor(m => item.Email)</td>
                                    <td>@Html.DisplayFor(m => item.Telefono)</td>
                                    <td>@Html.DisplayFor(m => item.Rol)</td>
                                    <td>
                                        <div class="text-center">
                                            <form asp-action="Borrar" asp-route-idUsuario="@item.Id">
                                                <a class="btn btn-primary" asp-controller="Usuarios" asp-action="Editar" asp-route-id="@item.Id">Editar</a>
                                                
                                                <!-- Hipervinculo para los claims -->
                                                <a class="btn btn-success" asp-controller="Usuarios" asp-action="AdministrarClaimsUsuario" asp-route-idUsuario="@item.Id" style="cursor:pointer">Asignar Permisos/Claims</a>

                                                @if (item.LockoutEnd == null || item.LockoutEnd < DateTime.Now)
                                                {
                                                    // Aqui se muestra la opcion para bloquear al usuario:
                                                    <button asp-action="BloquearDesbloquear" asp-route-idUsuario="@item.Id" class="btn btn-secondary text-white" style="cursor:pointer">
                                                        <strong>Bloquear</strong>
                                                    </button>
                                                }
                                                else
                                                {
                                                    // Aqui se muestra la opcion para desbloquear al usuario:
                                                    <button asp-action="BloquearDesbloquear" asp-route-idUsuario="@item.Id" class="btn btn-warning text-white" style="cursor:pointer">
                                                        <strong>Desbloquear</strong>
                                                    </button>
                                                }

                                                <button type="submit" onclick="return confirm('¿Está seguro de querer borrar este registro?')" class="btn btn-danger">
                                                    Borrar
                                                </button>
                                            </form>
                                        </div>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                }
                else
                {
                    <p>No hay registros.</p>
                }
            </div>
        </div>

    </div>
</div>

@section Scripts {
    @{
        await Html.RenderPartialAsync("_ValidationScriptsPartial");
    }

    <script type="text/javascript">
        $(document).ready(function () {
            $('#tablaUsuarios').DataTable({
                language: {
                    "decimal": "",
                    "emptyTable": "No hay información",
                    "info": "Mostrando _START_ a _END_ de _TOTAL_ Enttradas",
                    "infoEmpty": "Mostrando 0 a 0 de 0 Entradas",
                    "infoFiltered": "(Filtrado de _MAX_ total entradas)",
                    "infoPostFix": "",
                    "thousands": ",",
                    "lengthMenu": "Mostrar _MENU_ Entradas",
                    "loadingRecords": "Cargando...",
                    "processing": "Procesando...",
                    "search": "Buscar:",
                    "zeroRecords": "Sin resultados encontrados",
                    "paginate": {
                        "first": "Primero",
                        "last": "Último",
                        "next": "Siguiente",
                        "previous": "Anterior"
                    }
                }
            });
        })
    </script>
}